use std::process::Output;
use tokio::process::Command;
use warp::{Filter, Rejection};
use std::str::FromStr;

pub async fn command_output(command: &mut Command) -> std::io::Result<Output> {
    log::debug!("Shell command {:?}", command);
    let output = command.output().await;
    log::debug!("Output: {:?}", output);
    output
}

async fn param_handler<T: FromStr>(s: String) -> Result<T, Rejection>
where
    <T as FromStr>::Err: std::fmt::Debug,
{
    let new_s = match urlencoding::decode(&s) {
        Ok(v) => v,
        Err(_e) => return Err(warp::reject::not_found()),
    };
    let t = match T::from_str(&new_s) {
        Ok(v) => v,
        Err(_e) => return Err(warp::reject::not_found()),
    };
    Ok(t)
}
pub fn param<T: FromStr + Send + 'static>() -> impl Filter<Extract = (T,), Error = Rejection> + Copy
where
    <T as FromStr>::Err: std::fmt::Debug,
{
    warp::path::param::<String>().and_then(param_handler)
}
